
;BoottestT1interrupt.s
;******* Na plaatsen van bootloader in de PIC (flashen), de HEX-file van dit programma laden met de HIDbootloader 
;******* De configuratie zit in de bootloaderfile. Dit programma start op adres 0x1400.
;***************** maakt gebruik van linkerscript app_hid_boot_p24FJ64GB002mod.gld *********
;*********************** Lees ook de Leesmij-file *****************************************
;rev 06/09/1012	werkt	


.include "p24FJ64GB002.inc" 
.bss			;reserve space for variables, start at 0x1000 (see linkerscript)

i:	.space 2		
j:	.space 2	
k:	.space 2 
;*************************************************

	;The following code will be placed in the executable
	;code section.
.text

.global __reset
.global __T1Interrupt	;zie de lijst in de linkerscript

__reset:
	goto	hoofdprog
	
;*********************************************************************************
hoofdprog:

	mov 	#__SP_init, w15		;Initalize the Stack Pointer, set by linker to be after allocated data
	mov 	#__SPLIM_init,	W0	
	mov 	W0, SPLIM		;Initialize the stack limit register
	nop				;nop, safety in case of using w15 in next command	
					
	bclr.w	i, #5			;doet niets
						
start:		
	bclr.w	TRISB, #13
	bclr.w	TRISB, #14

	bclr.w	LATB, #14	
	bclr.w	LATB, #13
	mov	#0, w0
	mov	w0, i
	
	mov	#0x2030, w0	;00100000 00110000, prescale 256, Fosc/2
	mov	w0, T1CON
	mov	#0x7A12, w0	;levert 2Hz, gemeten
	mov	w0, PR1	
	bset	INTCON1, #NSTDIS
	bclr	INTCON2, #15	;use standard IVT
	mov	#0x7000, w0	;01110000 00000000, priority 7
	mov	w0, IPC0
	bclr.w	IFS0, #T1IF	;clear int
	bset	IEC0, #T1IE	;enable int
	bset	T1CON, #15	;start
	bset.w	LATB, #14	;groene led aan
	


;******************** loop *****************************************
main:		
loop:	bra	loop

;************** interrupt***************************
__T1Interrupt:	mov.w	w8, [w15++]
		bclr.w	IFS0, #T1IF	;clear int
		bclr.w	LATB, #14	;groen uit
		cp0.w	i
		bra z,	tr2
		bset.w	LATB, #13	;toggle geel
		bclr.w	i, #0
		bra	tr3
tr2:		bclr.w	LATB, #13
		bset.w	i, #0		
tr3:		mov.w	[--w15], w8		
		retfie

.end
