/********************************************************************
 FileName:     	HardwareProfile - PIC24FJ64GB002bord.h
 Dependencies:  See INCLUDES section
 Processor:     PIC24FJ64GB002
 Hardware:      PIC24FJ64GB002 board
 Compiler:      Microchip C30
 Company:       Microchip Technology, Inc.


 File Description:

 Change History:
  Rev   Date         Description
  1.0   19/07/2012  leds 3 en 4  en sw3 verwijderd; usb_sense=1 power_sense=0
  			poorten gekozen vlgs bordje
********************************************************************/

#ifndef HARDWARE_PROFILE_PIC24FJ64GB002_bord_H
#define HARDWARE_PROFILE_PIC24FJ64GB002_bord_H

    /*******************************************************************/
    /******** USB stack hardware selection options *********************/
    /*******************************************************************/
    //#define USE_USB_BUS_SENSE_IO
      #define USB_BUS_SENSE       1 
    //#define USE_SELF_POWER_SENSE_IO
      #define self_power          0	//no selfpower

    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/
    /******** Application specific definitions *************************/
    /*******************************************************************/
    /*******************************************************************/
    /*******************************************************************/

    /** Board definition ***********************************************/
    //These defintions will tell the main() function which board is
    //  currently selected.  This will allow the application to add
    //  the correct configuration bits as wells use the correct
    //  initialization functions for the board.  These defitions are only
    //  required in the stack provided demos.  They are not required in
    //  final application design.
    #define DEMO_BOARD PIC24FJ64GB004_PIM
    #define EXPLORER_16
    #define PIC24FJ64GB002_bord
    #define CLOCK_FREQ 32000000
    
    /** LED ************************************************************/
    #define mInitAllLEDs()      LATB &= 0x9FFF; TRISB &= 0x9FFF;
    
    #define mLED_1              LATBbits.LATB13
    #define mLED_2              LATBbits.LATB14


    #define mGetLED_1()         mLED_1
    #define mGetLED_2()         mLED_2
    
    #define mLED_1_On()         mLED_1 = 1;
    #define mLED_2_On()         mLED_2 = 1;
    
    #define mLED_1_Off()        mLED_1 = 0;
    #define mLED_2_Off()        mLED_2 = 0;
    
    #define mLED_1_Toggle()     mLED_1 = !mLED_1;
    #define mLED_2_Toggle()     mLED_2 = !mLED_2;

    #define mSetLED_1(in)         mLED_1 = in
    #define mSetLED_2(in)         mLED_2 = in
    
    /** SWITCH *********************************************************/
    #define mInitSwitch2()      TRISAbits.TRISA0=1;
    #define sw2                 PORTAbits.RA0
//    #define mInitSwitch2()      TRISBbits.TRISB2=1;
//    #define sw2                 PORTBbits.RB2
   #define mInitAllSwitches()  mInitSwitch2();
    /** I/O pin definitions ********************************************/
    #define INPUT_PIN 1
    #define OUTPUT_PIN 0

#endif  //HARDWARE_PROFILE_PIC24FJ64GB002_bord_H
