
;Testconfigint.s

;*** Dit is een programma dat in de PIC moet worden geflashed. In het programma wordt een interrupt gebruikt (T1). Het linkerscript is p24FJ64GB002.gld.
;*** Het programma start op 0x200 en de variabelen staan op 0x800 en volgende. De configuratie is op basis van de interne FRC.
;Het programma laat 1 led  knipperen.

;rev 09/09/2012	werkt


.include "p24FJ64GB002.inc" 
/** _CONFIG2 opties:
**
**   Primary Oscillator Select:
**     POSCMOD_EC           EC Oscillator mode selected
**     POSCMOD_XT           XT Oscillator mode selected
**     POSCMOD_HS           HS Oscillator mode selected
**     POSCMOD_NONE         Primary Oscillator disabled
**
**   I2C1 Pin Select bit:
**     I2C1SEL_SEC          Use alternate SCL1/SDA1 pins for I2C1
**     I2C1SEL_PRI          Use default SCL1/SDA1 pins for I2C1 
**
**   IOLOCK One-Way Set Enable:
**     IOL1WAY_OFF          The IOLOCK bit can be set and cleared using the unlock sequence
**     IOL1WAY_ON           Once set, the IOLOCK bit cannot be cleared
**
**   OSCO Pin Configuration:
**     OSCIOFNC_ON          OSCO pin functions as port I/O (RA3)
**     OSCIOFNC_OFF         OSCO pin functions as clock output (CLKO)
**
**   Clock Switching and Fail-Safe Clock Monitor:
**     FCKSM_CSECME         Sw Enabled, Mon Enabled
**     FCKSM_CSECMD         Sw Enabled, Mon Disabled
**     FCKSM_CSDCMD         Sw Disabled, Mon Disabled
**
**   Initial Oscillator Select:
**     FNOSC_FRC            Fast RC Oscillator (FRC)
**     FNOSC_FRCPLL         Fast RC Oscillator with Postscaler and PLL module (FRCPLL)
**     FNOSC_PRI            Primary Oscillator (XT, HS, EC)
**     FNOSC_PRIPLL         Primary Oscillator with PLL module (XTPLL, HSPLL, ECPLL)
**     FNOSC_SOSC           Secondary Oscillator (SOSC)
**     FNOSC_LPRC           Low-Power RC Oscillator (LPRC)
**     FNOSC_FRCDIV         Fast RC Oscillator with Postscaler (FRCDIV)
**
**   96MHz PLL Startup Select:
**     PLL96MHZ_OFF         96 MHz PLL Startup is enabled by user in software( controlled with the PLLEN bit)
**     PLL96MHZ_ON          96 MHz PLL Startup is enabled automatically on start-up
**
**   USB 96 MHz PLL Prescaler Select:
**     PLLDIV_NODIV         Oscillator input used directly (4 MHz input)
**     PLLDIV_DIV2          Oscillator input divided by 2 (8 MHz input)
**     PLLDIV_DIV3          Oscillator input divided by 3 (12 MHz input)
**     PLLDIV_DIV4          Oscillator input divided by 4 (16 MHz input)
**     PLLDIV_DIV5          Oscillator input divided by 5 (20 MHz input)
**     PLLDIV_DIV6          Oscillator input divided by 6 (24 MHz input)
**     PLLDIV_DIV8          Oscillator input divided by 8 (32 MHz input)
**     PLLDIV_DIV12         Oscillator input divided by 12 (48 MHz input)
**
**   Internal External Switchover:
**     IESO_OFF             IESO mode (Two-Speed Start-up) disabled
**     IESO_ON              IESO mode (Two-Speed Start-up) enabled
**
*/
	config __CONFIG1, WDTPS_PS1 & FWPSA_PR32 & WINDIS_OFF & FWDTEN_OFF & ICS_PGx1 & GWRP_OFF & GCP_OFF & JTAGEN_OFF
	config __CONFIG2, POSCMOD_NONE & I2C1SEL_PRI & IOL1WAY_OFF & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_FRCPLL & PLL96MHZ_ON & PLLDIV_NODIV & IESO_ON  	    
	config __CONFIG3, WPFP_WPFP0 & SOSCSEL_SOSC & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM
	config __CONFIG4, DSWDTPS_DSWDTPS3 & DSWDTOSC_LPRC & RTCOSC_SOSC & DSBOREN_OFF & DSWDTEN_OFF


.bss			;reserve space for variables

i:	.space 2		
j:	.space 2	
k:	.space 2 
;*************************************************

	;The following code will be placed in the executable
	;code section (0x200).
.text

.global __reset
.global __T1Interrupt 


__reset:
	goto	hoofdprog
	
;*********************************************************************************
hoofdprog:

	mov 	#__SP_init, w15		;Initalize the Stack Pointer, set by linker to be after allocated data
	mov 	#__SPLIM_init,	W0	
	mov 	W0, SPLIM		;Initialize the stack limit register
	nop				;nop, safety in case of using w15 in next command	
					
	bclr.w	i, #5			;just testing...
				
	mov.w	#0xFFFF, w0
	mov.w	w0, AD1PCFGL		;AD1PCFGL = 0xFFFF, all ports digital			
	bset.w	CLKDIV, #PLLEN		;CLKDIVbits.PLLEN = 1
	bset.w	CLKDIV, #RCDIV0		;CLKDIVbits.RCDIV0 = 1, deelt door 2; met noPLLDIV is de CPUfrequentie 32 MHz
						
start:		
	bclr.w	TRISB, #13
	bclr.w	TRISB, #14

	bclr.w	LATB, #14	
	bclr.w	LATB, #13
	mov	#0, w0
	mov	w0, i
	
	mov	#0x2030, w0	;00100000 00110000, prescale 256, Fosc/2
	mov	w0, T1CON
	mov	#0x7A12, w0	;levert XHz, afhankelijk van de postscalers
	mov	w0, PR1	
	bset	INTCON1, #NSTDIS
	bclr	INTCON2, #15	;use standard IVT
	mov	#0x7000, w0	;01110000 00000000, priority 7
	mov	w0, IPC0
	bclr.w	IFS0, #T1IF	;clear int
	bset	IEC0, #T1IE	;enable int
	bset	T1CON, #15	;start
	bset.w	LATB, #14	;groene led aan
	


;******************** loop *****************************************
main:		
loop:	bra	loop


;************** interrupt***************************
__T1Interrupt:	mov.w	w8, [w15++]
		bclr.w	IFS0, #T1IF	;clear int
		bclr.w	LATB, #14	;groen uit
		cp0.w	i
		bra z,	tr2
		bset.w	LATB, #13	;toggle geel
		bclr.w	i, #0
		bra	tr3
tr2:		bclr.w	LATB, #13
		bset.w	i, #0		
tr3:		mov.w	[--w15], w8		
		retfie

.end
