;USBbouncetest.s

;*** Dit is een programma dat gebruik maakt van een deel van de USB-routines die in de bootloader zitten.
;*** Daarom moet eerst de bootloader geladen worden (geflashed). Daarna kan met het PC-programma HIDbootloader dit programma 
;*** geladen worden (USB). De extra USB-routines van dit programma staan in de USBdevicetasks.ins en USBinout.inc files.
;*** De USB descriptors staan in ISBdescriptors.inc en de USB variabelen in USBvariabelen.inc.
;*** Het linkerscript is app_hid_boot_p24FJ64GB002.gld
;******* De configuratie zit in de bootloaderfile. Lees ook de Leesmij-file.

;Dit programma werkt samen met het PC-programma USBsnelheid.exe. Het PC-programma zendt 250 maal een pakket via de USB bus naar 
;het PIC-bordje dat de data ongewijzigd retourneert. De PC controleert of er geen fouten zijn gemaakt en geeft de totale tijdsduur in seconden.
;Wacht na het aansluiten van het bordje tot de emulatie is afgerond.

;rev 08/09/1012		werkt

.include "p24FJ64GB002.inc" 

VendorID = 0xBC0B
ProductID = 0x2009	;snelheidstest

;************************************************  
.bss			;reserve space for variables
.include "USBvariabelen.inc"
USBvariabelen:			.space 0x300	;reserveer ruimte voor USBvariabelen in INC-file 

i:	.space 2		;eigen variabelen		
j:	.space 2	
k:	.space 2 
;*************************************************
;The following code will be placed in the executable code section.
.text
.global __reset
__reset:
	mov 	#__SP_init, w15		;Initalize the Stack Pointer, set by linker to be after allocated data
	mov 	#__SPLIM_init,	W0	
	mov 	W0, SPLIM		;Initialize the stack limit register
	nop				;nop, safety in case of using w15 in next command	
					
	bclr.w	i, #5			;just for testing, doet niets  					
start:		
	bclr.w	TRISB, #13		;leds
	bclr.w	TRISB, #14

	bclr.w	LATB, #14	
	bset.w	LATB, #13		;geel

;******************** loop *****************************************
main:		rcall	USBinitialize
mainloop:	rcall	USBDeviceTasks	;07a0

		rcall	GetUSBpacket	;als w0=0 dan geen commando
		btst.z	w0, #1
		bra z,	mainloop	;no command or idle

;Prepare a response packet
		mov.w 	#_PacketToPC, w0
		mov.w 	#_PacketFromPC, w1
		mov.b	#64, w7
pfff:	
		mov.b 	[w1++], w8		;put  packetitem in w8
		mov.b 	w8, [w0++]		;and in outarray
		dec.b	w7, w7
		bra z,	p0F54
		bra	pfff
p0F54:		rcall	ReplyUSB
		bra	mainloop
		
.include "USBinout.inc"
.include "USBdevicetaskshandler.inc"
.include "USBdescriptors.inc"
.end
