;USBcommandtest.s

;*** Dit is een programma dat gebruik maakt van een deel van de USB-routines die in de bootloader zitten.
;*** Daarom moet eerst de bootloader geladen worden (geflashed). Daarna kan met het PC-programma HIDbootloader dit programma 
;*** geladen worden (USB). De extra USB-routines van dit programma staan in de USBdevicetasks.ins en USBinout.inc files.
;*** De USB descriptors staan in ISBdescriptors.inc en de USB variabelen in USBvariabelen.inc.
;*** Het linkerscript is app_hid_boot_p24FJ64GB002.gld
;******* De configuratie zit in de bootloaderfile. Lees ook de Leesmij-file.

;Dit programma wacht op een pakket van de PC. Begint dit pakket met het karakter 2 dan gaat een led branden.
;Het programma zendt het ontvangen pakket retour naar de PC. Met het PC-programma PICcommand werkt het simpel samen.
;Wacht na het aansluiten van het bordje op de emulatie van de USB.


;rev 08/09/1012		werkt

.include "p24FJ64GB002.inc" 

VendorID = 0xBC0B
ProductID = 0xCC10	;direct PIC-control


.include "USBdevicetaskshandler.inc"
.include "USBdescriptors.inc"
.include "USBinout.inc"
;***********************************************
.bss			;reserve space for variables
.include "USBvariabelen.inc"
USBvariabelen:			.space 0x300	;reserveer ruimte voor USBvariabelen in INC-file 

i:	.space 2		;eigen variabelen		
j:	.space 2	
k:	.space 2 
;*************************************************
;The following code will be placed in the executable code section.
.text
.global __reset
__reset:
	mov 	#__SP_init, w15		;Initalize the Stack Pointer, set by linker to be after allocated data
	mov 	#__SPLIM_init,	W0	
	mov 	W0, SPLIM		;Initialize the stack limit register
	nop				;nop, safety in case of using w15 in next command	
					
	bclr.w	i, #5			;just for testing, doet niets  					
start:		
	bclr.w	TRISB, #13		;leds
	bclr.w	TRISB, #14

	bclr.w	LATB, #14	
	bclr.w	LATB, #13

;******************** loop *****************************************
main:		rcall	USBinitialize
mainloop:	rcall	USBDeviceTasks	

		rcall	GetUSBpacket	;als w0=0 dan geen packet of de bus is idle
		btst.z	w0, #1
		bra z,	mainloop	;blijf wachten op een packet
		
		bclr.w 	LATB, #13	;led geel uit
		
;welk commando?		
		mov.w 	#_PacketFromPC, w1	;address of packetinarray
		mov.b 	[w1], w1		;zet eerste packetitem in w1
		sub.b 	#'2', w1		;is het '2'?
		bra nz,	p0EFA			;nee, geef alleen antwoord aan de PC (retourneer packet)
		bset.w 	LATB, #13		;led geel aan

		
p0EFA:		
;Prepare a response packet
		mov.w 	#_PacketToPC, w0	;pointer to outarray
		mov.w 	#_PacketFromPC, w1	;pointer to inarray
		mov.b	#64, w7			;aantal bytes
pfff:	
		mov.b 	[w1++], w8		;zet packetitem in w8
		mov.b 	w8, [w0++]		;en in outarray
		dec.b	w7, w7			;alle items
		bra z,	p0F54			;als klaar dan verzenden
		bra	pfff
p0F54:		rcall	ReplyUSB		;zendt pakket naar PC
		bra	mainloop
		
.end
