USB_EP0_BUFF_SIZE =	8
USB_MAX_NUM_INT =	1	
USB_MAX_EP_NUMBER =	1
USB_DESCRIPTOR_DEVICE =			0x01	;bDescriptorType for a Device Descriptor.
USB_DESCRIPTOR_CONFIGURATION =		0x02	;bDescriptorType for a Configuration Descriptor.
USB_DESCRIPTOR_STRING =			0x03	;bDescriptorType for a String Descriptor.
USB_DESCRIPTOR_INTERFACE =		0x04	;bDescriptorType for an Interface Descriptor.
USB_DESCRIPTOR_ENDPOINT =	 	0x05	;bDescriptorType for an Endpoint Descriptor.
USB_DESCRIPTOR_DEVICE_QUALIFIER = 	0x06	;bDescriptorType for a Device Qualifier.
USB_DESCRIPTOR_OTHER_SPEED =		0x07	;bDescriptorType for a Other Speed Configuration.
USB_DESCRIPTOR_INTERFACE_POWER =	0x08	;bDescriptorType for Interface Power.
USB_DESCRIPTOR_OTG =			0x09	;bDescriptorType for an OTG Descriptor.
HID_INTF_ID =			0x00
HID_INTF =			0x03
HID_EP =			1
HID_INT_OUT_EP_SIZE =		64
HID_INT_IN_EP_SIZE =		64
HID_NUM_OF_DSC =		1
HID_RPT01_SIZE =		29
;Class Descriptor Types 
DSC_HID =			0x21
DSC_RPT =			0x22
DSC_PHY =			0x23
_INT =				0x03		;Interrupt Transfer
_EP_IN =			0x80
_EP_OUT =			0x00
;.ascii	"we are the champions"
_USB_SD_Ptr:	.word 0x8000+_sd000
		.word 0x8000+_sd001
		.word 0x8000+_sd002
_USB_CD_Ptr:	.word 0x8000+_configDescriptor1		
;--------------------------------------------------------------------------------------
_hid_rpt01:
;Class specific descriptor - HID mouse
;ROM struct{BYTE report[HID_RPT01_SIZE];}hid_rpt01={
.byte	0x06, 0x00, 0xFF	;Usage Page = 0xFF00 (Vendor Defined Page 1)
.byte	0x09, 0x01		;Usage (Vendor Usage 1)
.byte	0xA1, 0x01		;Collection (Application)
.byte	0x19, 0x01		;Usage Minimum 
.byte	0x29, 0x40		;Usage Maximum 	;64 input usages total (0x01 to 0x40)
.byte	0x15, 0x00		;Logical Minimum (data bytes in the report may have minimum value = 0x00)
.byte	0x26, 0xFF, 0x00 	;Logical Maximum (data bytes in the report may have maximum value = 0x00FF = unsigned 255)
.byte	0x75, 0x08		;Report Size: 8-bit field size
.byte	0x95, 0x40		;Report Count: Make sixty-four 8-bit fields (the next time the parser hits an "Input", "Output", or "Feature" item)
.byte	0x81, 0x00		;Input (Data, Array, Abs): Instantiates input packet fields based on the above report size, count, logical min/max, and usage.
.byte	0x19, 0x01		;Usage Minimum 
.byte	0x29, 0x40		;Usage Maximum 	;64 output usages total (0x01 to 0x40)
.byte	0x91, 0x00		;Output (Data, Array, Abs): Instantiates output packet fields.	Uses same report size and count as "Input" fields, since nothing new/different was specified to the parser since the "Input" item.
.word	0xC0			;End Collection

;-----------------------------------------------------------------------------------------
_sd002:
;Product string descriptor
;string[18];}sd002={
sizsd002 = (18+1)*2
.byte	sizsd002, USB_DESCRIPTOR_STRING
.word	'U','S','B',' ','H','I','D',' ','p','r','o','g','r','a','m','m','e',' '
_sd001:
;Manufacturer string descriptor
;string[25];}sd001={
sizsd001 = (25+1)*2
.byte	sizsd001, USB_DESCRIPTOR_STRING
.word	'B','E','A','C','O','N',' ','2','0','1','2',' ','b','e','n','z','e','e','l','a','n','d',' ',' ','.'
_sd000:
;Language code string descriptor
;string[1];}sd000={
sizsd000 = (1+1)*2
.byte	sizsd000,USB_DESCRIPTOR_STRING
.word 	0x0409

;-----------------------------------------------------------------------------------------
_configDescriptor1:
;* Configuration 1 Descriptor *;
.byte	0x09				;sizeof(USB_CFG_DSC), Size of this descriptor in bytes
.byte	USB_DESCRIPTOR_CONFIGURATION	;CONFIGURATION descriptor type
.byte	0x29,0x00			;Total length of data for this cfg
.byte	1				;Number of interfaces in this cfg
.byte	1				;Index value of this configuration
.byte	0				;Configuration string index
.byte	0xC0				;Attributes, see usbd.h
.byte 	50				;Max power consumption (2X mA)
    ;* Interface Descriptor *;
.byte	0x09				;sizeof(USB_INTF_DSC), Size of this descriptor in bytes
.byte	USB_DESCRIPTOR_INTERFACE	;INTERFACE descriptor type
.byte	0				;Interface Number
.byte	0				;Alternate Setting Number
.byte	2				;Number of endpoints in this intf
.byte	HID_INTF			;Class code
.byte	0	 			;Subclass code
.byte	0	 			;Protocol code
.byte	0				;Interface string index

HIDclassdescr:
	;* HID Class-Specific Descriptor *;
.byte	0x09			;sizeof(USB_HID_DSC)+3, Size of this descriptor in bytes RRoj hack
.byte	DSC_HID			;HID descriptor type
.byte	0x11, 0x01		;HID Spec Release Number in BCD format (1.11)
.byte	0x00			;Country Code (0x00 for Not supported)
.byte	HID_NUM_OF_DSC		;Number of class descriptors see usbcfg.h
.byte	DSC_RPT			;Report descriptor type
.byte	HID_RPT01_SIZE, 0x00	;sizeof(hid_rpt01), Size of the report descriptor
	
	;* Endpoint Descriptor *;
.byte	0x07			;*sizeof(USB_EP_DSC)*;
.byte	USB_DESCRIPTOR_ENDPOINT	;Endpoint Descriptor
.byte	HID_EP | _EP_IN		;EndpointAddress
.byte	_INT			;Attributes
.byte	0x40, 0x00		;size
.byte	0x01			;Interval

	;* Endpoint Descriptor *;
.byte	0x07			;*sizeof(USB_EP_DSC)*;
.byte	USB_DESCRIPTOR_ENDPOINT	;Endpoint Descriptor
.byte	HID_EP | _EP_OUT	;EndpointAddress
.byte	_INT			;Attributes
.byte	0x40, 0x00		;size
.byte	0x01,00			;Interval, uitlijning

;-------------------------------------------------------------------------------------------
_device_dsc:
	;device
.byte	0x12, USB_DESCRIPTOR_DEVICE	;Size of this descriptor in bytes,  DEVICE descriptor type
.word	0x0110		 	;USB Spec Release Number in BCD format
.word	0x0000			;Class Code, Subclass code
.byte	0x00, USB_EP0_BUFF_SIZE	;Protocol code, Max packet size for EP0 see usbcfg.h
.word	VendorID		;0xBC0B			;Vendor ID
.word	ProductID		;0xCC10		 	;Product ID: USB direct control
.word	0x0001		 	;Device release number in BCD format
.byte	0x01, 0x02		;Manufacturer string index, Product string index
.byte	0x00, 0x01		;Device serial number string index, Number of possible configurations
