
#define		USBCBInitEP	0x115A
;.org 0xE0			;0x006a

;---------------------Function  void USBDeviceTasks(void)--------------------------------------------------
USBDeviceTasks:
label07A0: 	mov.d 	w8, [w15++]
		cp0.w 	_USBDeviceState	;if(USBDeviceState == DETACHED_STATE)	
		bra nz,	label07C4
 		clr.w 	U1CON			;U1CON = 0;			 
		clr.w 	U1IE			;U1IE = 0, Mask all USB interrupts			
;Enable/set things like: pull ups, full/low-speed mode,  set the ping pong mode, and set internal transceiver
;SetConfigurationOptions();
 		clr.w  	U1CNFG1
  		clr.w  	U1CNFG2
  		bclr.b  U1OTGCON, #2
  	 	mov.w  	#0x9f,  w0
  		mov.w  	w0, U1EIE
  		mov.w  	w0, U1IE
  		bra 	label07BA
			
;Enable module & attach to bus  
label07B8:  	bset.b 	U1CON, #0
label07BA:  	mov.b 	U1CON, WREG	
		btst.z 	w0, #0
  		bra z, 	label07B8		;while(!U1CONbits.USBEN){U1CONbits.USBEN = 1;}
						;moved to the attached state
  		mov.w 	#0x1, w0		;USBDeviceState = ATTACHED_STATE;
 		mov.w  	w0, _USBDeviceState
;if(USBDeviceState == ATTACHED_STATE)
label07C4:	mov.w	_USBDeviceState, w0
  		sub.w 	w0 , #1, [w15]
  		bra nz,	label07DC

;if(!USBSE0Event)
  		mov.b 	U1CON, WREG
		btst.z  w0, #6
		bra nz,	label07DC
		
  		setm.w 	U1IR			;USBClearInterruptRegister(U1IR),  Clear all USB interrupts
		clr.w 	U1IE			;U1IE=0 , Mask all USB interrupts
		bset.b 	U1IE, #0		;USBResetIE = 1, Unmask RESET interrupt
		bset.b 	U1IE, #4		;USBIdleIE = 1, Unmask IDLE interrupt
		mov.w 	#0x2, w0		;USBDeviceState = POWERED_STATE;	
		mov.w  w0, _USBDeviceState

;* Task A: Service USB Activity Interrupt
	
label07DC:  	mov.b 	U1OTGIR, WREG		;if(USBActivityIF && USBActivityIE)
  		btst.z  w0, #4
  		bra z, 	label07FA
  		mov.b 	U1OTGIE, WREG
  		btst.z  w0, #4
  		bra z, 	label07FA	
		mov.w 	#0x10, w8		;USBClearInterruptFlag(USBActivityIFReg,USBActivityIFBitNum);	
		mov.w 	w8, U1OTGIR

;*******************************************************************
;void USBWakeFromSuspend(void)
;USBBusIsSuspended = FALSE;
label07EC:	clr.w 0x09ce
;USB_WAKEUP_FROM_SUSPEND_HANDLER(EVENT_RESUME,0,0);
  		clr.w 	w2
  		clr.w 	w1
  		mov.w 	#0x74, w0
  		rcall 	label119E
;USBActivityIE = 0;
  		bclr.b 	U1OTGIE, #4
;USBClearInterruptFlag(USBActivityIFReg,USBActivityIFBitNum);
  		mov.w 	w8, U1OTGIR
;end USBWakeFromSuspen

;* Pointless to continue servicing if the device is in suspend mode.
label07FA: 	mov.b 	U1PWRC, WREG		;if(USBSuspendControl==1)
 		btst.z  w0, #1
		bra nz,	label0D0A	

;* Task B: Service USB Bus Reset Interrupt.
		mov.b 	U1IR, WREG		;if(USBResetIF && USBResetIE)
  		btst.z  w0, #0
  		bra z, 	label0816
  		mov.b 	U1IE, WREG
  		btst.z  w0, #0
  		bra z,	label0816
			
label080C:	rcall 	USBDeviceInit		;0x000550, USBDeviceInit(), roept geen andere routines op, maakt gebruik van bekende registers
		
;Re-enable the interrupts since the USBDeviceInit() function will  disable them.  This will do nothing in a polling setup
;USBUnmaskInterrupts();
		mov.w 	#0x4, w0		;USBDeviceState = DEFAULT_STATE;
  		mov.w  	w0,_USBDeviceState	
		mov.w 	#0x1, w0		;USBClearInterruptFlag(USBResetIFReg,USBResetIFBitNum);
  		mov.w  	w0, U1IR

;* Task C: Service other USB interrupts
label0816:	mov.b 	U1IR, WREG		;if(USBIdleIF && USBIdleIE)
  		btst.z  w0, #4
  		bra z, 	label0836	
  		mov.b 	U1IE, WREG
  		btst.z  w0, #4
  		bra z, 	label0836	
;USBActivityIE = 1;                  // Enable bus activity interrupt
label0822:	bset.b 	U1OTGIE,#4
;USBClearInterruptFlag(USBIdleIFReg,USBIdleIFBitNum);
		mov.w 	#0x10,w8
		mov.w 	w8,U1IR
;USBBusIsSuspended = TRUE;
 		mov.w 	#0x1,w0
		mov.w 	w0,_USBBusIsSuspended
;USB_SUSPEND_HANDLER(EVENT_SUSPEND,0,0);
		clr.w 	w2
		clr.w 	w1
		mov.w 	#0x75,w0
		rcall 	label119E
;USBClearInterruptFlag(USBIdleIFReg,USBIdleIFBitNum);
		mov.w 	w8, U1IR		;USBClearInterruptFlag(USBIdleIFReg,USBIdleIFBitNum);
	 
;if(USBSOFIF)
label0836:	mov.b 	U1IR, WREG
  		btst.z  w0, #2
  		bra z, 	label085A	

;if(USBSOFIE)
  		mov.b 	U1IE, WREG
  		btst.z  w0, #2
  		bra z, 	label084A	
	 
  		mov.w 	#0x1, w2		;USB_SOF_HANDLER(EVENT_SOF,0,1);
  		clr.w 	w1
  		mov.w 	#0x73, w0
  	 	rcall	label119E
		
label084A:	mov.w 	#0x4, w0		;USBClearInterruptFlag(USBSOFIFReg,USBSOFIFBitNum);
 		mov.w  	w0,U1IR
			
;Decrement our status stage counter.
;if(USBStatusStageTimeoutCounter != 0u)
  		mov.b 	_USBStatusStageTimeoutCounter, WREG
  		bra z, 	label0858
		dec.b  	w0, w0			;USBStatusStageTimeoutCounter--;
  		mov.b  	WREG, _USBStatusStageTimeoutCounter
		bra nz,	label085A		;if(USBStatusStageTimeoutCounter == 0)

label0858:	rcall 0x0005e0			;USBCtrlEPAllowStatusStage(), does nothing if the status stage was already armed

;if(USBStallIF && USBStallIE)
label085A:	cp0.b 	U1IR
  		bra ge,	label0886
  		cp0.b 	U1IE
  		bra ge,	label0886
;
;if(U1EP0bits.EPSTALL == 1)
label0862:	mov.b 	U1EP0, WREG
		btst.z 	w0, #1
  		bra z, 	label0882
;UOWN - if 0, owned by CPU, if 1, owned by SIE
;if((pBDTEntryEP0OutCurrent->STAT.Val == _USIE) && (pBDTEntryIn[0]->STAT.Val == (_USIE|_BSTALL)))
  		mov.w 	_pBDTEntryEP0OutCurrent, w2
  		mov.b 	[w2+1], w1
  		mov.b 	#0x80, w0
  		sub.b 	w1, w0, [w15]
  		bra nz,	label0880
  		mov.w 	_pBDTEntryIn, w0
  		mov.b 	[w0+1], w1
  		mov.b 	#0x84, w0
  		sub.b 	w1, w0, [w15]
  		bra nz,	label0880
;pBDTEntryEP0OutCurrent->STAT.Val = _USIE|_DAT0|_DTSEN|_BSTALL;
  		add.b 	w0, #8, w0
  		mov.b 	w0, [w2+1]
;U1EP0bits.EPSTALL = 0;Clear stall status
label0880:	bclr.b 	U1EP0, #1
;USBClearInterruptFlag(USBStallIFReg,USBStallIFBitNum);
label0882: 	mov.w 	#0x80, w0
  		mov.w 	w0, U1IR

;if(USBErrorIF && USBErrorIE)
label0886:	mov.b 	U1IR, WREG
		btst.z  w0, #1
  		bra z,	label08A0
		mov.b 	U1IE, WREG
  		btst.z  w0, #1
  		bra z,	label08A0
		mov.w	#0x1, w2	;USB_ERROR_HANDLER(EVENT_BUS_ERROR,0,1);
  		clr.w 	w1
  		mov.w	#0x7fff, w0
		rcall	label119E
		setm.w 	U1EIR	;USBClearInterruptRegister(U1EIR);		// This clears UERRIF
		mov.w	#0x2, w0	;USBClearInterruptFlag( USBErrorIFReg, USBErrorIFBitNum );
		mov.w	w0, U1IR

;if(USBDeviceState < DEFAULT_STATE)
label08A0:	mov.w 	_USBDeviceState, w0
		sub.w  	w0, #3, [w15]
  		bra leu,label0D0A

;* Task D: Servicing USB Transaction Complete Interrupt

;if(USBTransactionCompleteIE)
  		mov.b 	U1IE, WREG	
		btst.z  w0, #3
  		bra z,	label0D0A
  		clr.b	w9

;if(USBTransactionCompleteIF)
label08AE:	mov.b 	U1IR, WREG
  		btst.z  w0, #3
  		bra z,	label0D0A

;Save and extract USTAT register info.  Will use this info later.
		mov.w 	U1STAT, w0	;USTATcopy.Val = U1STAT;
  		mov.b  	WREG,_USTATcopy
		ze  	w0, w1		;endpoint_number = USBHALGetLastEndpoint(USTATcopy);
  		lsr 	w1, #4, w0
  		mov.b  	WREG, _endpoint_number
		mov.w	#0x8, w4	
;USBClearInterruptFlagUSBTransactionCompleteIFReg,USBTransactionCompleteIFBitNum);
  		mov.w 	w4, U1IR

;USBCtrlEPService only services transactions over EP0. It ignores all other EP transactions.
;if(endpoint_number == 0)
  		cp0.b  	w0
  		bra 	nz,	label0CFC


;******************static void USBCtrlEPService(void)*********************************
;If we get to here, that means a successful transaction has just occurred on EP0.  This means "progress" has occurred in the ;currently pending control transfer, so we should re-initialize our timeout counter.

;USBStatusStageTimeoutCounter = USB_STATUS_STAGE_TIMEOUT;
label08C6:	mov.b 	#0x2d, w0
  		mov.b 	WREG, _USBStatusStageTimeoutCounter
;Check if the last transaction was on EP0 OUT endpoint (of any kind, to either the even or odd buffer if ping pong buffers ;used)
;if((USTATcopy.Val & USTAT_EP0_PP_MASK) == USTAT_EP0_OUT_EVEN)
  		mov.w 	w1, w3
  		bclr 	w3, #2
  		cp0.w 	w3
  		bra nz,	label0C90
;Point to the EP0 OUT buffer of the buffer that arrived
;pBDTEntryEP0OutCurrent = (volatile BDT_ENTRY*)&BDT[(USTATcopy.Val & USTAT_EP_MASK)>>2];
  		and.w 	#0xfc, w1
  		mov.w 	#_BDT, w0
  		add.w 	w1, w0, w2
  		mov.w 	w2, _pBDTEntryEP0OutCurrent
;Set the next out to the current out packet
;pBDTEntryEP0OutNext = pBDTEntryEP0OutCurrent;
  		mov.w 	w2, _pBDTEntryEP0OutNext
;Toggle it to the next ping pong buffer (if applicable)
;If the current EP0 OUT buffer has a SETUP packet
;if(pBDTEntryEP0OutCurrent->STAT.PID == PID_SETUP)
  		mov.b 	[w2+1], w0
  		and.b 	#0x3c, w0
  		mov.b 	#0x34, w1
  		sub.b 	w0, w1, [w15]
  		bra nz,	label0BDE
  		mov.w 	w2, w1
  		mov.w 	#_SetupPkt, w2

;*(BYTE*)((BYTE*)&SetupPkt + setup_cnt) = *(BYTE*)ConvertToVirtualAddress(pBDTEntryEP0OutCurrent->ADR);
label08EA:	mov.w 	[w1+2], w0
  		mov.b 	[w0], w0
  		mov.b 	w0, [w2+w3]
;pBDTEntryEP0OutCurrent->ADR++;
  		mov.w 	[w1+2], w0
  		inc.w 	w0, w0
  		mov.w 	w0, [w1+2]
  		inc.w 	w3, w3

;for(setup_cnt = 0;setup_cnt < 8u;setup_cnt++) //SETUP data packets always contain exactly 8 bytes.
  		sub.w 	w3, #8, [w15]
  		bra nz,	label08EA
;pBDTEntryEP0OutCurrent->ADR = ConvertToPhysicalAddress(&SetupPkt);
  		mov.w 	w2, [w1+2]
    
;********************************************************************
;void USBCtrlTrfSetupHandler(void)
;1. Re-initialize state tracking variables related to control transfers.
;shortPacketStatus = SHORT_PKT_NOT_USED;
  		clr.b 	_shortPacketStatus
;USBDeferStatusStagePacket = FALSE;
  		clr.w 	_USBDeferStatusStagePacket
;USBDeferINDataStagePackets = FALSE;
  		clr.w 	_USBDeferINDataStagePackets
;USBDeferOUTDataStagePackets = FALSE;
  		clr.w 	_USBDeferOUTDataStagePackets
;BothEP0OutUOWNsSet = FALSE; 
  		clr.w 	_BothEP0OutUOWNsSet
;controlTransferState = WAIT_SETUP;
  		clr.b 	_controlTransferState
;Abandon any previous control transfers that might have been using EP0.
;Ordinarily, nothing actually needs abandoning, since the previous control
;transfer would have completed successfully prior to the host sending the next
;SETUP packet.  However, in a timeout error case, or after an EP0 STALL event,
;one or more UOWN bits might still be set.  If so, we should clear the UOWN bits,
;so the EP0 IN/OUT endpoints are in a known inactive state, ready for re-arming
;by the class request handler that will be called next.
;pBDTEntryIn[0]->STAT.Val &= ~(_USIE);  
  		mov.w 	_pBDTEntryIn, w1
  		mov.b 	[w1+1], w0
  		bclr.b 	w0, #7			;090E
  		mov.b 	w0, [w1+1]
;pBDTEntryIn[0]->STAT.Val &= ~(_USIE);   
  		mov.w 	_pBDTEntryIn, w1
  		mov.b 	[w1+1], w0
  		bclr.b 	w0, #7
  		mov.b 	w0, [w1+1]
;pBDTEntryEP0OutNext->STAT.Val &= ~(_USIE);      
  		mov.w 	_pBDTEntryEP0OutNext, w1
  		mov.b 	[w1+1], w0
  		bclr.b 	w0, #7
  		mov.b 	w0, [w1+1]
;inPipes[0].info.Val = 0;
  		clr.b 	_inPipes+2
;inPipes[0].wCount.Val = 0;
  		clr.w 	_inPipes+4
;outPipes[0].info.Val = 0;
  		clr.b 	_outPipes+2
;outPipes[0].wCount.Val = 0;
  		clr.b	_outPipes+3
  		clr.b 	_outPipes+4

;********************************************************************
;void USBCheckStdRequest(void)
;if(SetupPkt.RequestType != USB_SETUP_TYPE_STANDARD_BITFIELD) return;
  		mov.b 	_SetupPkt, WREG
		and.b 	#0x60, w0
  		bra nz,	label0B7A
;switch(SetupPkt.bRequest)
  		mov.b	_SetupPkt+1, WREG
  		ze 	w0, w0
  		mov.w 	#0x0, w1
  		sub.w 	w0, #11, [w15]
  		subb.w 	w1, #0, [w15]
  		bra 	gtu,	label0B7A
label093E: 	bra 	0x001400
label0940:	bra 	label0A06
label0942:	bra 	label0A60
label0944:	bra 	label0B7A
label0946:	bra 	label0A60
label0948:	bra 	label0B7A
label094A:	bra 	label0958
label094C:	bra 	label095E
label094E:	bra 	label0B72
label0950:	bra 	label0A02
label0952: 	bra 	label09B4
label0954:	bra 	label0B50
label0956: 	bra 	label0B64

;case USB_REQUEST_SET_ADDRESS:
;inPipes[0].info.bits.busy = 1;         // This will generate a zero length packet
label0958:  	bset.b 	_inPipes+2, #7
;USBDeviceState = ADR_PENDING_STATE;    // Update state only
  		mov.w 	#0x8, w0
  		bra 	label09F2

;********************************************************************
;static void USBStdGetDscHandler(void)
;if(SetupPkt.bmRequestType == 0x80)
label095E:	mov.w 	#_SetupPkt, w1
  		mov.b 	[w1], w1
  		mov.b 	#0x80, w0
  		sub.b 	w1, w0, [w15]
  		bra nz,	label0B7A
;inPipes[0].info.Val = USB_EP0_ROM | USB_EP0_BUSY | USB_EP0_INCLUDE_ZERO;
  		mov.b 	#0xc0, w0
  		mov.b 	WREG, _inPipes+2
;switch(SetupPkt.bDescriptorType)
  		mov.b 	_SetupPkt+3, WREG
  		sub.b 	w0, #2, [w15]
  		bra z, 	label0982
  		sub.b 	w0, #3, [w15]
  		bra z, 	label0998
  		sub.b 	w0, #1, [w15]
  		bra nz,	label09B0
;inPipes[0].pSrc.bRom = (ROM BYTE*)USB_USER_DEVICE_DESCRIPTOR;
  		mov.w 	#psvoffset(_device_dsc), w0	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  		mov.w 	w0, _inPipes
;inPipes[0].wCount.Val = sizeof(device_dsc);
  		mov.w 	#0x12, w0
  		bra	label09AC
;inPipes[0].pSrc.bRom = *(USB_USER_CONFIG_DESCRIPTOR+SetupPkt.bDscIndex);
label0982:	mov.b _SetupPkt+2, WREG
  		ze 	w0, w0
  		add.w 	w0, w0, w0
  		mov.w 	#psvoffset(_USB_CD_Ptr), w1	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  		mov.w 	[w0+w1], w1
  		mov.w 	w1, _inPipes
;inPipes[0].wCount.byte.LB = *(inPipes[0].pSrc.bRom+2);
  		mov.b 	[w1+2], w0
  		mov.b 	WREG, _inPipes+4
;inPipes[0].wCount.byte.HB = *(inPipes[0].pSrc.bRom+3);
  		mov.b 	[w1+3], w0
  		mov.b 	WREG, _inPipes+5
  		bra 	label0B7A
;if(SetupPkt.bDscIndex<USB_NUM_STRING_DESCRIPTORS)
label0998: 	mov.b 	_SetupPkt+2, WREG
  		sub.b 	w0, #2, [w15]
  		bra 	gtu,	label09B0
;inPipes[0].pSrc.bRom = *(USB_SD_Ptr+SetupPkt.bDscIndex);
  		mov.b 	_SetupPkt+2, WREG
  		ze 	w0, w0
  		add.w 	w0, w0, w0
  		mov.w 	#psvoffset(_USB_SD_Ptr), w1	;!!!!!!!!!!!!!!!!!!!!!!!!!
  		mov.w 	[w0+w1], w0
  		mov.w 	w0, _inPipes
;inPipes[0].wCount.Val = *inPipes[0].pSrc.bRom;                 
  		ze 	[w0], w0
label09AC:	mov.w 	w0, _inPipes+4
  		bra 	label0B7A
;inPipes[0].info.Val = 0;
label09B0:  	clr.b 	_inPipes+2
  		bra 	label0B7A
;end USBStdGetDscHandler

;********************************************************************
;USBStdSetCfgHandler(void)
;This will generate a zero length packet   inPipes[0].info.bits.busy = 1;         
label09B4: 	bset.b 	_inPipes+2, #7
    
;Clear all of the endpoint control registers
;DisableNonZeroEndpoints(USB_MAX_EP_NUMBER);
  		clr.w 	U1EP1
  		clr.w 	w0
  		mov.w 	#_BDT, w1

;BDT[i].Val = 0x00;
label09BC: 	clr.w 	[w1++]
  		clr.w 	[w1++]
  		inc.w 	w0, w0
          
;Clear all of the BDT entries
;for(i=0;i<(sizeof(BDT)/sizeof(BDT_ENTRY));i++)
  		sub.w 	w0, #4, [w15]
  		bra nz,	label09BC
;Assert reset request to all of the Ping Pong buffer pointers
;USBPingPongBufferReset = 1;                                
  		bset.b 	U1CON, #1
  		clr.w 	w0
  		mov.w	#_ep_data_in, w3
  		mov.b	w0, w1
  		mov.w	#_ep_data_out, w2
;ep_data_in[i].Val = 0u;
label09D0:	mov.b 	w1, [w0+w3]
;ep_data_out[i].Val = 0u;
  		mov.b 	w1, [w0+w2]
  		inc.w 	w0, w0
;for(i = 0;i < (BYTE)(USB_MAX_EP_NUMBER+1u);i++)
  		sub.w 	w0, #2, [w15]
  		bra nz,	label09D0
;clear the alternate interface settings
;memset((void*)&USBAlternateInterface, 0x00,USB_MAX_NUM_INT);
  		mov.w 	w1, w0
  		mov.b 	WREG, _USBAlternateInterface
;Stop trying to reset ping pong buffer pointers
;USBPingPongBufferReset = 0;
  		bclr.b 	U1CON, #1
;pBDTEntryIn[0] = (volatile BDT_ENTRY*)&BDT[EP0_IN_EVEN];
  		mov.w 	#_BDT+4, w0
  		mov.w 	w0, _pBDTEntryIn
;Set the next out to the current out packet
;pBDTEntryEP0OutCurrent = (volatile BDT_ENTRY*)&BDT[EP0_OUT_EVEN];
  		mov.w 	#_BDT, w0
  		mov.w 	w0, _pBDTEntryEP0OutCurrent
;pBDTEntryEP0OutNext = pBDTEntryEP0OutCurrent;
  		mov.w 	w0, _pBDTEntryEP0OutNext
          
;set the current configuration
;USBActiveConfiguration = SetupPkt.bConfigurationValue;
  		mov.b 	_SetupPkt+2, WREG
  		mov.b 	WREG, _USBActiveConfiguration
;if(USBActiveConfiguration == 0)
  		bra nz,	label09F6
;USBDeviceState = ADDRESS_STATE;
  		mov.w 	#0x10, w0
label09F2:  	mov.w 	w0, _USBDeviceState
  		bra 	label0B7A
;initialize the required endpoints
;USB_SET_CONFIGURATION_HANDLER(EVENT_CONFIGURED,(void*)&USBActiveConfiguration,1);
label09F6:  	mov.w 	#0x1, w2
  		mov.w 	#_USBActiveConfiguration, w1
  		mov.w 	#0x1, w0
  		rcall 	label119E
;Otherwise go to the configured state.  Update the state variable last, after performing all of the set configuration 
;related initialization tasks.
;USBDeviceState = CONFIGURED_STATE;		
  		mov.w 	#0x20, w0
  		bra 	label09F2
;end USBStdSetCfgHandler
   
;case USB_REQUEST_GET_CONFIGURATION:
;inPipes[0].pSrc.bRam = (BYTE*)&USBActiveConfiguration;      // Set Source
label0A02:	mov.w 	#_USBActiveConfiguration,w0
		bra 	label0B58

;********************************************************************
;void USBStdGetStatusHandler(void)
;CtrlTrfData[0] = 0;              // Initialize content
label0A06:  	clr.b 	_CtrlTrfData
;CtrlTrfData[1] = 0;
  		clr.b 	_CtrlTrfData+1
;switch(SetupPkt.Recipient)
  		mov.b 	_SetupPkt, WREG
  		and.w 	w0, #31, w0
  		sub.w 	w0, #1, [w15]
  		bra z, 	label0A26
  		sub.w 	w0, #2, [w15]
  		bra z, 	label0A2A
  		cp0.w 	w0
  		bra nz,	label0A50
;case USB_SETUP_RECIPIENT_DEVICE_BITFIELD:
;inPipes[0].info.bits.busy = 1;
  		bset.b 	_inPipes+2, #7
;if(RemoteWakeup == TRUE)
  		mov.w 	_RemoteWakeup, w0
  		sub.w 	w0, #1, [w15]
  		bra nz,	label0A50
;CtrlTrfData[0]|=0x02;
  		bset.b 	_CtrlTrfData, #1
  		bra 	label0A50
;case USB_SETUP_RECIPIENT_INTERFACE_BITFIELD:
;inPipes[0].info.bits.busy = 1;  // No data to update
label0A26: 	bset.b 	_inPipes+2, #7
  		bra 	label0A50
;case USB_SETUP_RECIPIENT_ENDPOINT_BITFIELD:
;inPipes[0].info.bits.busy = 1;
label0A2A:  	bset.b 	_inPipes+2, #7
;if(SetupPkt.EPDir == 0)
  		cp0.b 	_SetupPkt+4
  		bra lt,	label0A3A
;p = (BDT_ENTRY*)pBDTEntryOut[SetupPkt.EPNum];
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w 	#_pBDTEntryOut, w1
  		bra 	label0A42
;p = (BDT_ENTRY*)pBDTEntryIn[SetupPkt.EPNum];
label0A3A:	mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w 	#_pBDTEntryIn, w1
label0A42:	mov.w 	[w0+w1], w0
;if((p->STAT.UOWN == 1) && (p->STAT.BSTALL == 1))
  		mov.w 	#psvoffset(__reset), w1		;!!!!!!!!!!!!!!!!!!!!
  		and.w 	w1, [w0], w0
  		sub.w 	w0, w1, [w15]
  		bra nz, label0A50
;CtrlTrfData[0]=0x01;  Set bit0
  		mov.b 	#0x1, w0
  		mov.b 	WREG, _CtrlTrfData
;if(inPipes[0].info.bits.busy == 1)
label0A50: 	btst.b 	_inPipes+2, #7
		bra z, 	label0B7A
  ;inPipes[0].pSrc.bRam = (BYTE*)&CtrlTrfData, Set Source
  		mov.w 	#_CtrlTrfData, w0
  		mov.w 	w0, _inPipes
;inPipes[0].info.bits.ctrl_trf_mem = USB_EP0_RAM;            // Set memory type
  		bset.b 	_inPipes+2, #0
;inPipes[0].wCount.v[0] = 2;                      // Set data count
  		mov.b 	#0x2, w0
  		mov.b 	WREG, _inPipes+4
  		bra 	label0B7A

;********************************************************************
;void USBStdFeatureReqHandler(void)
;Check if the host sent a valid SET or CLEAR feature (remote wakeup) request.
;if((SetupPkt.bFeature == USB_FEATURE_DEVICE_REMOTE_WAKEUP)&&
label0A60:	mov.b 	_SetupPkt+2, WREG
  		sub.b 	w0, #1, [w15]
  		bra nz,	label0A7C
  		mov.b 	_SetupPkt, WREG
  		and.b 	w0, #31, w0
  		bra nz, 	label0A7C
;inPipes[0].info.bits.busy = 1;
  		bset.b 	_inPipes+2, #7
;if(SetupPkt.bRequest == USB_REQUEST_SET_FEATURE)
  		mov.b 	_SetupPkt+1, WREG
  		sub.b 	w0, #3, [w15]
  		bra nz,	label0A7A
;RemoteWakeup = TRUE;
  		mov.w 	#0x1, w0
  		mov.w 	w0, _RemoteWakeup
  		bra	label0A7C
;RemoteWakeup = FALSE;
label0A7A:  	clr.w _RemoteWakeup
;Check if the host sent a valid SET or CLEAR endpoint halt request.
;if((SetupPkt.bFeature == USB_FEATURE_ENDPOINT_HALT)&&
label0A7C:	cp0.b 	_SetupPkt+2
  		bra nz,	label0B7A
  		mov.b 	_SetupPkt, WREG
  		and.b 	w0, #31, w0
  		sub.b 	w0, #2, [w15]
  		bra nz,	label0B7A
  		mov.b 	_SetupPkt+4, WREG
  		and.b 	w0, #15, w0
  		bra z, 	label0B7A
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		sub.w 	w0, #1, [w15]
  		bra gt,	label0B7A
  		mov.w 	_USBDeviceState, w1
  		mov.w 	#0x20, w0
  		sub.w 	w1, w0, [w15]
  		bra nz,	label0B7A
;The request was valid.  Take control of the control transfer and perform the host requested action.
;inPipes[0].info.bits.busy = 1;
  		bset.b 	_inPipes+2, #7
;Fetch a pointer to the BDT that the host wants to SET/CLEAR halt on.
;if(SetupPkt.EPDir == OUT_FROM_HOST)
  		cp0.b 	_SetupPkt+4
  		bra lt,	label0AB6
;p = (BDT_ENTRY*)pBDTEntryOut[SetupPkt.EPNum];
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w	#_pBDTEntryOut, w1
  		mov.w 	[w0+w1], w3
;current_ep_data.Val = ep_data_out[SetupPkt.EPNum].Val;
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		mov.w	#_ep_data_out, w1
  		bra	label0AC6
;p = (BDT_ENTRY*)pBDTEntryIn[SetupPkt.EPNum];
label0AB6:  	mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w	#_pBDTEntryIn, w1
  		mov.w 	[w0+w1], w3
;current_ep_data.Val = ep_data_in[SetupPkt.EPNum].Val;
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		mov.w	#_ep_data_in, w1
label0AC6:  	mov.b 	[w0+w1], w2
;Update the BDT pointers with the new, next entry based on the feature request
;if(SetupPkt.EPDir == OUT_FROM_HOST)
  		cp0.b 	_SetupPkt+4
  		bra lt,	label0AD6
;pBDTEntryOut[SetupPkt.EPNum] = (volatile BDT_ENTRY *)p;
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w	#_pBDTEntryOut, w1
  		bra	label0ADE
;pBDTEntryIn[SetupPkt.EPNum] = (volatile BDT_ENTRY *)p;
label0AD6:  	mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w	#_pBDTEntryIn, w1
label0ADE:  	mov.w 	w3, [w0+w1]
;Check if it was a SET_FEATURE endpoint halt request
;if(SetupPkt.bRequest == USB_REQUEST_SET_FEATURE)
  		mov.b 	_SetupPkt+1, WREG
  		sub.b	w0, #3, [w15]
  		bra nz,	label0B0A
;if(p->STAT.UOWN == 1)
  		cp0.w 	[w3]
  		bra ge,	label0B00
;Mark that we are terminating this transfer and that the user needs to be notified later
;if(SetupPkt.EPDir == OUT_FROM_HOST)
  		cp0.b 	_SetupPkt+4
  		bra lt,	label0AF6
;ep_data_out[SetupPkt.EPNum].bits.transfer_terminated = 1;
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		mov.w	#_ep_data_out, w1
  		bra	label0AFC
;ep_data_in[SetupPkt.EPNum].bits.transfer_terminated = 1;
label0AF6:  	mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		mov.w	#_ep_data_in, w1
label0AFC:  	add.w 	w0, w1, w0
  		bset.b 	[w0], #1
;Then STALL the endpoint
;p->STAT.Val |= _USIE|_BSTALL;
label0B00: 	mov.b 	[w3+1], w0
  		mov.b	#0x84, w1
  		ior.b	w0, w1, w0
  		mov.b	w0, [w3+1]
  		bra	label0B7A
;if((current_ep_data.bits.transfer_terminated != 0) || (p->STAT.UOWN == 1))
label0B0A:  	btst.z 	w2, #1
  		bra nz,	label0B12
  		cp0.w 	[w3]
  		bra ge,	label0B3A
;We are going to call the user transfer terminated callback.
;Clear the flag so we know we took care of it and don't need to call it again later.
;if(SetupPkt.EPDir == OUT_FROM_HOST)
label0B12: 	cp0.b 	_SetupPkt+4
  		bra lt,	label0B1E
;ep_data_out[SetupPkt.EPNum].bits.transfer_terminated = 0;
  		mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		mov.w	#_ep_data_out, w1
  		bra	label0B24
;ep_data_in[SetupPkt.EPNum].bits.transfer_terminated = 0;
label0B1E: 	mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		mov.w	#_ep_data_in, w1
label0B24:  	add.w 	w0, w1, w0
  		bclr.b 	[w0], #1
;Clear UOWN and remove the STALL condition.   
;In this case we also need to set the DTS bit to 1 so that
;it toggles to DATA0 the next time the application firmware
;calls USBTransferOnePacket() (or equivalent macro).  
;p->STAT.Val &= ~(_USIE | _BSTALL);
  		mov.b 	[w3+1], w0
  		and.b	#0x7b, w0
;p->STAT.Val |= _DAT1;
  		bset w0, #6
  		mov.b	w0, [w3+1]
;Let the application firmware know a transaction just
;got terminated by the host, and that it is now free to
;re-arm the endpoint or do other tasks if desired.                                        
;USB_TRANSFER_TERMINATED_HANDLER(EVENT_TRANSFER_TERMINATED,p,sizeof(p));
  		mov.w 	#0x2, w2
  		mov.w 	w3, w1
  		mov.w 	#0x5, w0
  		rcall 	label119E
  		bra	label0B42
;Clear UOWN and remove the STALL condition.   
;In this case we also need to set the DTS bit to 1 so that  it toggles to DATA0 the next time the application firmware
;calls USBTransferOnePacket() (or equivalent macro).  
;p->STAT.Val &= ~(_USIE | _BSTALL);
label0B3A:  	mov.b 	[w3+1], w0
  		and.b	#0x7b, w0
;p->STAT.Val |= _DAT1;
  		bset.b 	w0, #6
  		mov.b	w0, [w3+1]
;pUEP = (unsigned char*)(&U1EP0+SetupPkt.EPNum);
label0B42:  	mov.b 	_SetupPkt+4, WREG
  		and.w 	w0, #15, w0
  		add.w 	w0, w0, w0
  		mov.w 	#U1EP0, w1
  		add.w 	w0, w1, w0
;Clear the STALL bit in the UEP register
;*pUEP &= ~UEP_STALL;         
  		bclr.b 	[w0], #1
  		bra	label0B7A
;case USB_REQUEST_GET_INTERFACE:
;inPipes[0].pSrc.bRam = (BYTE*)&USBAlternateInterface[SetupPkt.bIntfID];// Set source
label0B50:	mov.b 	_SetupPkt+4, WREG
  		ze 	w0, w0
  		mov.w	#_USBAlternateInterface, w1
  		add.w 	w0, w1, w0
label0B58: 	mov.w 	w0, _inPipes
;inPipes[0].info.bits.ctrl_trf_mem = USB_EP0_RAM;            // Set memory type
  		bset.b 	_inPipes+2, #0
;inPipes[0].wCount.v[0] = 1;                      // Set data count
  		mov.b	#0x1, w0
  		mov.b	WREG, _inPipes+4
;inPipes[0].info.bits.busy = 1;
  		bset.b 	_inPipes+2, #7
  		bra	label0B7A
;case USB_REQUEST_SET_INTERFACE:
;inPipes[0].info.bits.busy = 1;
label0B64:  	bset.b 	_inPipes+2, #7
;USBAlternateInterface[SetupPkt.bIntfID] = SetupPkt.bAltID;
  		mov.b 	_SetupPkt+4, WREG
  		ze 	w0, w0
  		mov.w	#_USBAlternateInterface, w1
  		mov.w	#_SetupPkt+2, w2
  		mov.b 	[w2], [w0+w1]
  		bra	label0B7A
;case USB_REQUEST_SET_DESCRIPTOR:
;USB_SET_DESCRIPTOR_HANDLER(EVENT_SET_DESCRIPTOR,0,0);
label0B72: 	clr.w 	w2
  		clr.w 	w1
  		mov.w 	#0x2, w0
  		rcall 	label119E
;
;end USBCheckStdRequest
   
;--------------------------------------------------------------------------
;2. Now find out what was in the SETUP packet, and begin handling the request.
;--------------------------------------------------------------------------
;USBCheckStdRequest();                                            //Check for standard USB "Chapter 9" requests.
;USB_DISABLE_NONSTANDARD_EP0_REQUEST_HANDLER(EVENT_EP0_REQUEST,0,0);//Check for USB device class specific ;requests
label0B7A: 	clr.w 	w2
  		clr.w 	w1
  		mov.w 	#0x3, w0
  		rcall 	label119E

;******************************************************************************
;void USBCtrlEPServiceComplete(void)
;USBPacketDisable = 0;
  		bclr.b 	U1CON, #5
     
;Check the busy bits and the SetupPtk.DataDir variables to determine what type of
;control transfer is currently in progress.  We need to know the type of control
;transfer that is currently pending, in order to know how to properly arm the 
;EP0 IN and EP0 OUT endpoints.
;if(inPipes[0].info.bits.busy == 0)
  		mov.w 	_inPipes+2, w8
  		and.w 	#0x80, w8
  		bra nz,	label0BB0
;if(outPipes[0].info.bits.busy == 1)
  		cp0.b 	_outPipes+2
  		bra ge,	label0B9E
;controlTransferState = CTRL_TRF_RX;
  		mov.b	#0x2, w0
  		mov.b	WREG, _controlTransferState
;         
;1. Prepare OUT EP to receive data, unless a USB class request handler
;function decided to defer the data stage (ex: because the intended
;RAM buffer wasn't available yet) by calling USBDeferDataStage().
;If it did so, it is then responsible for calling USBCtrlEPAllowDataStage(),
;once it is ready to begin receiving the data.
;if(USBDeferOUTDataStagePackets == FALSE)
  		cp0.w 	_USBDeferOUTDataStagePackets
  		bra nz,	label0B98
;USBCtrlEPAllowDataStage();
  		rcall 	0x000752
;2.  IN endpoint 0 status stage will be armed by USBCtrlEPAllowStatusStage() 
;after all of the OUT data has been received and consumed, or if a timeout occurs.
;USBStatusStageEnabledFlag2 = FALSE;
label0B98: 	mov.w 	w8, _USBStatusStageEnabledFlag2
;USBStatusStageEnabledFlag1 = FALSE;
  		mov.w 	w8, _USBStatusStageEnabledFlag1
  		bra	label0D04
;If no one knows how to service this request then stall.
;Must also prepare EP0 to receive the next SETUP transaction.
;pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
label0B9E:	mov.b	#0x8, w1
  		mov.w 	_pBDTEntryEP0OutNext, w0
  		mov.b	w1, [w0]
;pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
  		mov.w 	_pBDTEntryEP0OutNext, w1
  		mov.w	#_SetupPkt, w0
  		mov.w 	w0, [w1+2]
;pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT0|_DTSEN|_BSTALL;
  		mov.b	#0x8c, w0
  		mov.b	w0, [w1+1]
  		bra	label0CCA
;if(SetupPkt.DataDir == USB_SETUP_DEVICE_TO_HOST_BITFIELD)
label0BB0:	cp0.b _SetupPkt
  		bra ge,	label0BC0
;controlTransferState = CTRL_TRF_TX;
  		mov.b	#0x1, w0
  		mov.b	WREG, _controlTransferState

;if(USBDeferINDataStagePackets == FALSE)
  		cp0.w 	_USBDeferINDataStagePackets
  		bra nz,	label0BD4
;USBCtrlEPAllowDataStage();
  		rcall 	0x000752		;roept 06f8, verder geen call's of registers
  		bra	label0BD4

;option can take care of this for you.
;controlTransferState = CTRL_TRF_RX;  //Since this is a HOST_TO_DEVICE control transfer
label0BC0:	mov.b	#0x2, w0
  		mov.b	WREG, _controlTransferState
;1. Prepare OUT EP to receive the next SETUP packet.
;pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
  		mov.b	#0x8, w1
  		mov.w 	_pBDTEntryEP0OutNext, w0
  		mov.b	w1, [w0]
;pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
  		mov.w 	_pBDTEntryEP0OutNext, w1
  		mov.w	#_SetupPkt, w0
		mov.w 	w0, [w1+2]
;pBDTEntryEP0OutNext->STAT.Val = _USIE|_BSTALL;
  		mov.b	#0x84, w0
  		mov.b	w0, [w1+1]
;2. Prepare for IN status stage of the control transfer
;USBStatusStageEnabledFlag2 = FALSE;
label0BD4: 	clr.w 	_USBStatusStageEnabledFlag2
;USBStatusStageEnabledFlag1 = FALSE;
  		clr.w 	_USBStatusStageEnabledFlag1
;if(USBDeferStatusStagePacket == FALSE)
label0BD8:	cp0.w 	_USBDeferStatusStagePacket
  		bra nz,	label0D04
  		bra	label0C72
           
;******************************************************************************
;void USBCtrlTrfOutHandler(void)
;if(controlTransferState == CTRL_TRF_RX)
label0BDE:	mov.w	#_controlTransferState, w0	
		mov.b	#0x2, w1
  		subr.b	w1, [w0], [w15]
  		bra nz,	label0C76
;end USBCtrlEPServiceComplete

;******************************************************************************
;void USBCtrlTrfRxService(void)
;Load byteToRead with the number of bytes the host just sent us in the 
;last OUT transaction.
;byteToRead = pBDTEntryEP0OutCurrent->CNT;
		mov.b 	[w2], w4
     
;Update the "outPipes[0].wCount.Val", which keeps track of the total number of remaining bytes expected to be received ;from the host, in the control transfer.  First check to see if the host sent us more bytes than the application firmware was ;expecting to receive.
;if(byteToRead > outPipes[0].wCount.Val)
  		mov.b 	_outPipes+3, WREG
  		ze 	w0, w0
  		mov.w 	#_outPipes+4, w1	
  		mov.b 	[w1], w1
  		sl 	w1, #8, w1
  		ior.w 	w1, w0, w1
  		ze 	w4, w0
  		sub.w 	w0, w1, [w15]	
		bra leu,label0BFC
;byteToRead = outPipes[0].wCount.Val;
  		mov.b	w1, w4
;Reduce the number of remaining bytes by the number we just received.
;outPipes[0].wCount.Val = outPipes[0].wCount.Val - byteToRead;
label0BFC:	ze 	w4, w0
  		sub.w 	w1, w0, w0
  		mov.b	WREG, _outPipes+3
  		lsr 	w0, #8, w0
  		mov.b	WREG, _outPipes+4
  		mov.w	#_CtrlTrfData, w5
  		bra	label0C26
;*outPipes[0].pDst.bRam++ = CtrlTrfData[i];
label0C0A:	mov.b 	_outPipes, WREG
  		ze 	w0, w0
  		mov.w	#_outPipes+1, w1
  		mov.b 	[w1], w1
  		sl 	w1, #8, w1
  		ior.w 	w1, w0, w1
  		ze 	w2, w0
  		mov.b 	[w0+w5], [w1++]
  		mov.w 	w1, w0
  		mov.b	WREG, _outPipes
  		lsr w1, #8, w1
  		mov.w 	w1, w0
  		mov.b	WREG, _outPipes+1
  		inc.w 	w3, w3
label0C26: 	mov.b	w3, w2

;Copy the OUT DATAx packet bytes that we just received from the host,
;into the user application buffer space.
;for(i=0;i<byteToRead;i++)
  		sub.b	w3, w4, [w15]
  		bra nc,	label0C0A
  		mov.w 	_pBDTEntryEP0OutNext, w2
;If there is more data to receive, prepare EP0 OUT so that it can receive the next packet in the sequence.
;if(outPipes[0].wCount.Val > 0)
  		mov.w 	#_outPipes+3, w1	
  		mov.b 	[w1], w1
  		ze 	w1, w1
  		mov.b 	_outPipes+4, WREG
  		sl 	w0, #8, w0
  		ior.w 	w0, w1, w0
  		bra z, 	label0C50
;pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
		mov.b	#0x8, w0
  		mov.b	w0, [w2]
;pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&CtrlTrfData);
  		mov.w 	_pBDTEntryEP0OutNext, w1
  		mov.w	#_CtrlTrfData, w0
  		mov.w 	w0, [w1+2]
;if(pBDTEntryEP0OutCurrent->STAT.DTS == 0)
  		mov.w 	_pBDTEntryEP0OutCurrent, w0
  		mov.b 	[w0+1], w0
  		btst.z 	w0, #6
  		bra z, 	label0CD8
  		bra	label0CDC

;We have received all OUT packets that we were expecting receive for the control transfer.  
;Prepare EP0 OUT to the next SETUP transaction that may arrive.
;pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
label0C50:	mov.b	#0x8, w0
  		mov.b	w0, [w2]
;pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
  		mov.w 	_pBDTEntryEP0OutNext, w1
  		mov.w	#_SetupPkt, w0
  		mov.w 	w0, [w1+2]
;Configure EP0 OUT to receive the next SETUP transaction for any future control transfers. 
;However, set BSTALL in case the host tries to more data than it claims it was going to send.
;pBDTEntryEP0OutNext->STAT.Val = _USIE|_BSTALL;
  		mov.b	#0x84, w0
  		mov.b	w0, [w1+1]
;All data bytes for the host to device control write (OUT) have now received successfully.
;Go ahead and call the user specified callback function, to use/consume the control transfer data
;(ex: if the "void (*function)" parameter was non-NULL when USBEP0Receive() was called).
;if(outPipes[0].pFunc != NULL)
  		mov.w	#_outPipes+5, w1
  		mov.b 	[w1], w1
  		ze 	w1, w1
  		mov.b 	_outPipes+6, WREG
  		sl 	w0, #8, w0
  		ior.w 	w0, w1, w0
  		bra z, 	label0C6E
;outPipes[0].pFunc();
  		call 	w0
;outPipes[0].info.bits.busy = 0; 
label0C6E:	bclr.b 	_outPipes+2, #7
  		bra	label0BD8

;Ready to arm status stage IN transaction now, if the application firmware has completed processing the request.  
;If it is still busy and needs more time to finish handling the request, then the user callback (the one called by the 
;outPipes[0].pFunc();) should set the  USBDeferStatusStagePacket to TRUE (by calling USBDeferStatusStage()).  
;In this case, it is the application's firmware responsibility to call the USBCtrlEPAllowStatusStage() function, once it is fully ;done handling the request.
;Note: The application firmware must process the request and call USBCtrlEPAllowStatusStage() in a semi-timely fashion.  ;"Semi-timely" means either 50ms, 500ms, or 5 seconds, depending on the type of control transfer. 
 ;See the USB 2.0 specification section 9.2.6 for more details.
;if(USBDeferStatusStagePacket == FALSE)
;USBCtrlEPAllowStatusStage();
label0C72:	rcall 	0x0005e0	;gewone routine, geen andere call's of registers
  		bra	label0D04
;end USBCtrlTrfRxService
;USBCtrlTrfRxService()
;Copies the newly received data into the appropriate buffer and configures EP0 OUT for next transaction.

;controlTransferState = WAIT_SETUP;
label0C76:	exch 	w0, w3
  		mov.b	WREG, _controlTransferState
  		exch 	w0, w3
;Prepare EP0 OUT for the next SETUP transaction, however, it may have already been prepared if ping-pong buffering was ;enabled on EP0 OUT, and the last control transfer was of direction: device to host, see USBCtrlEPServiceComplete(). 
;If it was already prepared, do not want to do anything to the BDT.
;if(BothEP0OutUOWNsSet == FALSE)
  		cp0.w 	_BothEP0OutUOWNsSet
  		bra nz,	label0C8C
;pBDTEntryEP0OutNext->CNT = USB_EP0_BUFF_SIZE;
  		mov.b	w4, [w2]
;pBDTEntryEP0OutNext->ADR = ConvertToPhysicalAddress(&SetupPkt);
  		mov.w	#_SetupPkt, w0
  		mov.w 	w0, [w2+2]
;pBDTEntryEP0OutNext->STAT.Val = _USIE|_DAT0|_DTSEN|_BSTALL;			
  		mov.b	#0x8c, w0
  		mov.b	w0, [w2+1]
  		bra	label0D04
;BothEP0OutUOWNsSet = FALSE;
label0C8C:	mov.w 	w3, _BothEP0OutUOWNsSet
  		bra	label0D04
;if((USTATcopy.Val & USTAT_EP0_PP_MASK) == USTAT_EP0_IN)
label0C90:	sub.w 	w3, #8, [w15]
  		bra nz,	label0D04
          
;******************************************************************************
;void USBCtrlTrfInHandler(void)
;lastDTS = pBDTEntryIn[0]->STAT.DTS;
 label0C94:	mov.w 	_pBDTEntryIn, w0
  		mov.b 	[w0+1], w0
  		lsr 	w0, #6, w0
  		and.w 	w0, #1, w8
;switch to the next ping pong buffer
;if(USBDeviceState == ADR_PENDING_STATE)
  		mov.w	_USBDeviceState, w0
  		sub.w 	w0, #8, [w15]
  		bra nz, label0CB2
;U1ADDR = SetupPkt.bDevADR.Val;
  		mov.b 	_SetupPkt+2, WREG
  		ze 	w0, w0
  		mov.w 	w0, U1ADDR
;USBDeviceState=ADDRESS_STATE;
  		mov.w 	#0x10,w0
;if(U1ADDR != 0u)
  		cp0.w U1ADDR
  		bra nz,	label0CB0
;USBDeviceState=DEFAULT_STATE;
  		mov.w 	#0x4, w0
label0CB0:	mov.w 	w0, _USBDeviceState
;if(controlTransferState == CTRL_TRF_TX)
label0CB2: 	mov.w	#_controlTransferState, w0
  		mov.b	#0x1, w1
  		subr.b	w1, [w0], [w15]
  		bra nz,	label0CE2
;pBDTEntryIn[0]->ADR = ConvertToPhysicalAddress(CtrlTrfData);
  		mov.w	#_CtrlTrfData, w0
  		mov.w 	_pBDTEntryIn, w1
  		mov.w 	w0, [w1+2]
;USBCtrlTrfTxService();
  		rcall 	0x0006f8		;gewone USBroutine, geen andere call's of registers

;Check if we have already sent a short packet.  If so, configure the endpoint to STALL in response to any further IN tokens
;(in the case that the host erroneously tries to receive more data than it should).
;if(shortPacketStatus == SHORT_PKT_SENT)
  		mov.w	#_shortPacketStatus, w0
  		mov.b	#0x2, w1
		subr.b	w1, [w0], [w15]
  		bra nz,	label0CD2
;If a short packet has been sent, don't want to send any more,  stall next time if host is still trying to read.
;pBDTEntryIn[0]->STAT.Val = _USIE|_BSTALL;
label0CCA: 	mov.b	#0x84, w1
  		mov.w 	_pBDTEntryIn, w0
  		mov.b	w1, [w0+1]
  		bra	label0D04
label0CD2:	mov.w 	_pBDTEntryIn, w1
;if(lastDTS == 0)
  		cp0.b	w8
  		bra nz,	label0CDC
;pBDTEntryIn[0]->STAT.Val = _USIE|_DAT1|_DTSEN;
label0CD8:	mov.b	#0xc8, w0
  		bra	label0CDE
;pBDTEntryIn[0]->STAT.Val = _USIE|_DAT0|_DTSEN;
label0CDC:	mov.b	#0x88, w0
label0CDE: 	mov.b	w0, [w1+1]
  		bra	label0D04
;if(outPipes[0].info.bits.busy == 1)
label0CE2:	cp0.b 	_outPipes+2
  		bra ge,	label0CF8
;if(outPipes[0].pFunc != NULL)
  		mov.w	#_outPipes+5, w1
  		mov.b 	[w1], w1
  		ze 	w1, w1
  		mov.b 	_outPipes+6, WREG
  		sl 	w0, #8, w0
  		ior.w 	w0, w1, w0
  		bra z, 	label0CF6
;outPipes[0].pFunc();
  		call 	w0
;outPipes[0].info.bits.busy = 0;
label0CF6: 	bclr.b 	_outPipes+2, #7
;controlTransferState = WAIT_SETUP;
label0CF8:	clr.b 	_controlTransferState
  		bra	label0D04
		
label0CFC:	clr.w 	w2	;USB_TRANSFER_COMPLETE_HANDLER(EVENT_TRANSFER, (BYTE*)&USTATcopy.Val, 0);
  		mov.w	#_USTATcopy, w1
  		mov.w	#0x72, w0
  		rcall	label119E

  ;for(i = 0;i < 4u;i++), Drain or deplete the USAT FIFO entries.  If the USB FIFO ever gets full, USB bandwidth 
label0D04:	inc.b	w9, w9
  		sub.b	w9, #4, [w15]
  		bra nz,	label08AE		
label0D0A:	bclr.b 	IFS5, #6		;USBClearUSBInterrupt();
  		mov.d 	[--w15], w8
  		return


;0d010=userinit
;initialize the variable holding the handle for the last transmission
;USBOutHandle = 0;
 ;clr.w 	w1
 ;mov.w 	w1, _USBOutHandle
;USBInHandle = 0;
 ;mov.w 	w1, _USBInHandle
;---------------------------------------------------------------------------------------------------------------------
;		BOOL USER_USB_CALLBACK_EVENT_HANDLER(USB_EVENT event, void *pdata, WORD size)
;switch(event)
label119E:	sub.w 	w0, #1, [w15]
  		bra z, 	label11A8
  		sub.w 	w0, #3, [w15]
  		bra nz,	label11AE
		bra 	label11AC

;case EVENT_CONFIGURED:		USBCBInitEP();
label11A8:	rcall 	0x00115A		;USBCBInitEP	;label115A
  		bra 	label11AE

;case EVENT_EP0_REQUEST:		USBCBCheckOtherReq();
label11AC:	rcall	label11B0

label11AE:	retlw 	#0x1, w0

;*******************************************************************
 ;USBCBCheckOtherReq(void)
;USBCheckHIDRequest(void)
;if(SetupPkt.Recipient != USB_SETUP_RECIPIENT_INTERFACE_BITFIELD) return;
label11B0:	mov.b 	_SetupPkt, WREG
  		and.b	w0, #31, w0
  		sub.b	w0, #1, [w15]
  		bra nz,	label1246
;if(SetupPkt.bIntfID != HID_INTF_ID) return;
  		cp0.b 	_SetupPkt+4
  		bra nz,	label1246
;if(SetupPkt.bRequest == USB_REQUEST_GET_DESCRIPTOR)
label11BC:	mov.b 	_SetupPkt+1, WREG
  		sub.b	w0, #6, [w15]	
		bra nz,	label11F8
;switch(SetupPkt.bDescriptorType)
label11C2:	mov.w	#_SetupPkt+3, w1
  		mov.b 	[w1], w1
  		add.b	w0, #27, w0
  		sub.b	w1, w0, [w15]
  		bra z,	label11D4
  		inc.b	w0, w0
  		sub.b	w1, w0, [w15]
  		bra nz,	label11F8
  		bra 	label11E4
;case DSC_HID: //HID Descriptor	 
;if(USBActiveConfiguration == 1)
label11D4:	mov.w	#_USBActiveConfiguration, w0
  		mov.b	#0x1, w1
  		subr.b	w1, [w0], [w15]
  		bra nz,	label11F8
;USBEP0SendROMPtr(
  		mov.w	#psvoffset(HIDclassdescr), w0	;MSB=1 betekent program space visibility (aangevuld met PSVPAG, 0x0034)!!!!!!!!!!!!!!!!!!!
  		mov.w 	w0, _inPipes
  		mov.w	#0x9, w0
  		bra 	label11F2
;(ROM BYTE*)&configDescriptor1 + 18,	18 is a magic number.  It is the offset from start of the configuration descriptor to the start of the HID descriptor.
;sizeof(USB_HID_DSC)+3,
;USB_EP0_INCLUDE_ZERO);
;case DSC_RPT:  //Report Descriptor		
;if(USBActiveConfiguration == 1)
label11E4:	mov.w	#_USBActiveConfiguration, w0
  		mov.b	#0x1, w1
  		subr.b	w1, [w0], [w15]
  		bra nz,	label11F8
;USBEP0SendROMPtr(
  		mov.w	#psvoffset(_hid_rpt01), w0	;!!!!!!!!!!!
  		mov.w 	w0,_inPipes
  		mov.w	#0x1d, w0
label11F2: 	mov.w 	w0, _inPipes+4
  		mov.b	#0xc0, w0
  		mov.b	WREG,_inPipes+2
;(ROM BYTE*)&hid_rpt01,
;sizeof(hid_rpt01),	//See usbcfg.h
;USB_EP0_INCLUDE_ZERO);
;case DSC_PHY:  //Physical Descriptor
		
;if(SetupPkt.RequestType != USB_SETUP_TYPE_CLASS_BITFIELD)
label11F8:	mov.b 	_SetupPkt, WREG
  		and.b	#0x60, w0
  		mov.b	#0x20, w1
  		sub.b	w0, w1, [w15]
  		bra nz,	label1246
;switch(SetupPkt.bRequest)
label1202:	mov.b 	_SetupPkt+1, WREG
  		sub.b	w0, #3, [w15]
  		bra z,	label1230
  		bra gtu,label1210
  		sub.b	w0, #2, [w15]
  		bra nz,	label1246
  		bra 	label121A
label1210: 	sub.b	w0, #10, [w15]
  		bra z,	label1226
  		sub.b	w0, #11, [w15]
  		bra nz,	label1246
  		bra 	label123E
;case GET_IDLE:
;USBEP0SendRAMPtr(
label121A:	mov.w	#_idle_rate, w0
  		mov.w 	w0,_inPipes
  		mov.w	#0x1,w0
  		mov.w 	w0,_inPipes+4
  		mov.b	#0xc1, w0
  		bra 	label123A
;(BYTE*)&idle_rate,	1,
;USB_EP0_INCLUDE_ZERO);
;case SET_IDLE:
;USBEP0Transmit(USB_EP0_NO_DATA);
label1226:	mov.b	#0x80, w0
  		mov.b	WREG,_inPipes+2
;idle_rate = SetupPkt.W_Value.byte.HB;
  		mov.b 	_SetupPkt+3, WREG
  		mov.b	WREG,_idle_rate
  		return
;case GET_PROTOCOL:
;USBEP0SendRAMPtr(
label1230: 	mov.w	#_active_protocol, w0
  		mov.w 	w0,_inPipes
  		mov.w	#0x1, w0
		mov.w 	w0,_inPipes+4
  		mov.b	#0x81, w0
label123A: 	mov.b	WREG,_inPipes+2
  		return
;(BYTE*)&active_protocol,	1,
;USB_EP0_NO_OPTIONS);
;case SET_PROTOCOL:
;USBEP0Transmit(USB_EP0_NO_DATA);
label123E:	mov.b	#0x80, w0
  		mov.b	WREG,_inPipes+2
;active_protocol = SetupPkt.W_Value.byte.LB;
  		mov.b 	_SetupPkt+2, WREG
  		mov.b	WREG,_active_protocol
label1246:	return

