
;USBinout.s

;***************************************************************************
GetUSBpacket:	;levert w0=0 als er geen commando is of de USB niet actief
;if((USBDeviceState < CONFIGURED_STATE)||(USBSuspendControl==1)) return;
		mov.w 	_USBDeviceState,w0
 		sub.w 	w0, #31,[w15]
  		bra leu,endget
 		mov.b 	U1PWRC, WREG
 		btst.z 	w0, #1
		bra z, 	CheckUSBpacket
endget:		mov.w	#0, w0
		return

;-----------------------------------------------------------------------------
CheckUSBpacket:
		cp0.b 	_BootState	; if(BootState == IdleState)
		bra nz,	Endcheck	;er is wat binnengekomen
		
;If BootState= Idle then check in and out
		
;Are we done sending the last response.  We need to be before we receive the next command because we clear the ;PacketToPC buffer once we receive a command
		mov.w 	_USBInHandle,w0	; if(!USBHandleBusy(USBInHandle))
		cp0.w 	w0
		bra z,	p0EA0
		mov.b 	[w0+1],w0
		cp0.b 	w0
		bra lt,	endget

p0EA0:		mov.w 	_USBOutHandle,w0	; if(!USBHandleBusy(USBOutHandle)), Did we receive a command?
		cp0.w 	w0
		bra z,	p0EAC
		mov.b 	[w0+1], w0
		cp0.b 	w0
		bra lt,	endget		;geen commando, dus return met w0=0

;er is wat binnengekomen, dus overzetten naar goede buffer		
p0EAC:		clr.w 	w0
		mov.w 	#_PacketFromPC, w3
		mov.w 	#_PacketFromPCBuffer, w2
		mov.w 	#0x40, w1
		
; PacketFromPC.Contents[i] = PacketFromPCBuffer.Contents[i];
p0EB4:		mov.b 	[w2+w0], [w3+w0]
		inc.w 	w0, w0
		sub.w 	w0, w1, [w15]	; for(i = 0;i < TotalPacketSize;i++)
		bra nz,	p0EB4

;USBOutHandle = USBRxOnePacket(HID_EP,(BYTE*)&PacketFromPCBuffer,64);
		mov.b 	#0x40, w3			;lengte
		mov.w 	#_PacketFromPCBuffer, w2	;adres
		clr.b 	w1				;dir=from PC
		mov.b 	#0x1, w0			;EP1
		rcall 	USB_HANDLE_USBTransferOnePacket	;USB_HANDLE USBTransferOnePacket(BYTE ep,BYTE dir,BYTE* data,BYTE len)
		mov.w 	w0, _USBOutHandle
		mov.b 	#0x1, w0	;BootState = NotIdleState
		mov.b 	WREG, _BootState

;Prepare the next packet we will send to the host, by initializing the entire packet to 0x00.
;This saves code space, since we don't have to do it independently in the QUERY_DEVICE and GET_DATA cases.				mov.w 	#_PacketToPC, w0
		mov.w 	#_PacketToPC, w0
		mov.w 	#_PacketFromPC, w1
p0ED0:		clr.b 	[w0++]		;PacketToPC.Contents[i] = 0
		sub.w 	w0, w1, [w15]	;for(i = 0;i < TotalPacketSize;i++)
		bra z,	Endcheck
		bra	p0ED0
		
Endcheck:	setm	WREG	;w0=FFFF
		return

;-------------------------------------------------------------------------
ReplyUSB:

; if(!USBHandleBusy(USBInHandle))
		mov.w 	_USBInHandle, w0
		cp0.w 	w0
		bra z,	p10EA
		mov.b 	[w0+1], w0
		cp0.b 	w0
		bra lt,	endreply	;end of routine
	
; USBInHandle = USBTxOnePacket(HID_EP,(BYTE*)&PacketToPC.Contents[0],64);
p10EA:		mov.b 	#0x40, w3		;length
		mov.w 	#_PacketToPC, w2	;adres
		mov.b 	#0x1, w1		;dir IN
p10F0:		mov.b 	w1, w0			;EPnr 1
		rcall 	USB_HANDLE_USBTransferOnePacket	;USB_HANDLE USBTransferOnePacket(BYTE ep,BYTE dir,BYTE* data,BYTE len)
		mov.w 	w0,_USBInHandle
;BootState = IdleState, alles afgehandeld
		clr.b 	_BootState

endreply:	;End of routine	
		return	
		
		
			
;*************************************************************************		
USBinitialize:	rcall	USBDeviceInit	;0550
;initialize the variable holding the handle for the last transmission
		clr.w 	w1	
		mov.w 	w1, _USBOutHandle	;USBOutHandle = 0
		mov.w 	w1, _USBInHandle	;USBInHandle = 0
;BootState = IdleState;
		mov.w 	w1, w0
		mov.b 	WREG, _BootState
		return		
;----------------------------------------------------------------


