;testled2.s
	
;******* Na plaatsen van bootloader in de PIC (flashen), de HEX-file van dit programma laden met de HIDbootloader 
;******* De configuratie zit in de bootloaderfile. Dit programma start op adres 0x1400.
;***************** maakt gebruik van linkerscript app_hid_boot_p24FJ64GB002mod.gld *********
;******************* Lees ook de Leesmij-file **********************************************
;het programma zet twee leds afwisselend elk 1s aan en uit; met drukknop op poort A0 kan gepauseerd worden. De vertraging 
;wordt gehaald uit subroutines in de file Delays16MHz.inc.

;rev	08/09/2012	werkt 

.include "p24Fxxxx.inc"
 
.bss			;reserve space for variables, start at 0x1000
m:		.space 6	
Deltel1:	.space 2
Deltel2:	.space 2
Deltel3:	.space 2

	; The following code will be placed in the executable
	; code section.
.text
.global __reset
__reset:
	mov 	#__SP_init, w15		;Initalize the Stack Pointer, _SP_init set by linker to be after allocated data
	mov 	#__SPLIM_init, W0	
	mov 	W0, SPLIM		;Initialize the stack limit register
	nop				;needed to be safe
	
	bclr.w	m, #4			;test, kijk of data werkt
	
	;De volgende regels zijn uitgeschakeld omdat het bootloaderprogramma de poorten al digitaal maakt				
;	mov.w	#0xFFFF, w0
;	mov.w	w0, AD1PCFGL		;AD1PCFGL = 0xFFFF, all ports digital			
	bset.w	CLKDIV, #PLLEN		;CLKDIVbits.PLLEN = 1
	bset.w	CLKDIV, #RCDIV0		;CLKDIVbits.RCDIV0 = 1 (default), FRC = 8, postscaler devide by 2
					;met eveneens CLKDIVbits.RCDIV1 = 1 wordt de postscaler devide by 8
	call	delay1ms		;inregelen				
					
					
start:		
	bclr.w	TRISB, #13	;leds
	bclr.w	TRISB, #14
	bset.w	TRISA, #0
loop:
	mov.w	PORTA, w0
	btst.z	w0, #0
	bra nz,	lp2
	bset.w	LATB, #14
	bra	loop
lp2:
	bclr.w	LATB, #14	
	bset.w	LATB, #13
	call	delay1s
	bset.w	LATB, #14
	bclr.w	LATB, #13
	call	delay1s
	bclr.w	LATB, #14	
	goto	loop

	nop
	nop
	return
.include "delays16MHz.s"
.end
